#ifndef PKMNLIB_POKEMONPARTY_HPP
#define PKMNLIB_POKEMONPARTY_HPP

#include <CreatureLib/Battling/Models/CreatureParty.hpp>
#include <utility>
#include "Pokemon.hpp"
namespace PkmnLib::Battling {
    class PokemonParty : public CreatureLib::Battling::CreatureParty {
    public:
        PokemonParty(ArbUt::List<CreatureLib::Battling::Creature*> party)
            : CreatureLib::Battling::CreatureParty(std::move(party)) {}
        PokemonParty(std::initializer_list<CreatureLib::Battling::Creature*> party)
            : CreatureLib::Battling::CreatureParty(party) {}

        ArbUt::BorrowedPtr<Pokemon> GetAtIndex(int index) const {
            return CreatureLib::Battling::CreatureParty::GetAtIndex(index).As<Pokemon>();
        }
    };
}

#endif // PKMNLIB_POKEMONPARTY_HPP
