#ifndef PKMNLIB_MOVELIBRARY_HPP
#define PKMNLIB_MOVELIBRARY_HPP

#include <CreatureLib/Library/AttackLibrary.hpp>
#include "MoveData.hpp"
namespace PkmnLib::Library {
    class MoveLibrary : public CreatureLib::Library::AttackLibrary {
    public:
        MoveLibrary(size_t initialCapacity = 32) : CreatureLib::Library::AttackLibrary(initialCapacity) {}

        virtual ArbUt::BorrowedPtr<const MoveData> operator[](const ArbUt::BasicStringView& name) const {
            return Get(name);
        }

        inline bool TryGet(const ArbUt::BasicStringView& name, ArbUt::BorrowedPtr<const MoveData>& move) const {
            auto v = move.As<const MoveData::AttackData>();
            auto res = CreatureLib::Library::AttackLibrary::TryGet(name, v);
            move = v.As<const MoveData>();
            return res;
        }
        inline ArbUt::BorrowedPtr<const MoveData> Get(const ArbUt::BasicStringView& name) const {
            return CreatureLib::Library::AttackLibrary::Get(name).As<const MoveData>();
        }
    };
}

#endif // PKMNLIB_MOVELIBRARY_HPP
