#include "BasicScriptClass.hpp"
#include <cassert>

void BasicScriptClass::Register(asIScriptEngine* engine) {
    // As far as I am aware at the moment you can't create an abstract class with virtual members through the
    // application registry interface. As such, we just create it from string.
    [[maybe_unused]] int r = engine->GetModuleByIndex(0)->AddScriptSection("PkmnScript", R"(
shared abstract class PkmnScript {
  // CreatureLib methods
    void OnInitialize(const array<EffectParameter@> &in parameters){};
    void Stack(){};
    void OnRemove(){};
    void OnBeforeTurn(BaseTurnChoice@ choice){};
    void ChangeAttack(MoveTurnChoice@ choice, constString& changedMove){};
    void PreventAttack(ExecutingMove@ attack, bool& result){};
    void FailAttack(ExecutingMove@ attack, bool& result){};
    void StopBeforeAttack(ExecutingMove@ attack, bool& result){};
    void OnBeforeAttack(ExecutingMove@ attack){};
    void FailIncomingAttack(ExecutingMove@ attack, Pokemon@ target, bool& result){};
    void IsInvulnerable(ExecutingMove@ attack, Pokemon@ target, bool& result){};
    void OnAttackMiss(ExecutingMove@ attack, Pokemon@ target){};
    void ChangeAttackType(ExecutingMove@ attack, Pokemon@ target, uint8 hit, uint8& outType){};
    void ChangeEffectiveness(ExecutingMove@ attack, Pokemon@ target, uint8 hit, float& effectiveness){};
    void PreventSecondaryEffects(ExecutingMove@ attack, Pokemon@ target, uint8 hit, bool& outResult){};
    void OnSecondaryEffect(ExecutingMove@ attack, Pokemon@ target, uint8 hit){};
    void OnAfterHits(ExecutingMove@ attack, Pokemon@ target){};
    void PreventSelfSwitch(SwitchTurnChoice@ choice, bool& prevented){};

    void ModifyEffectChance(ExecutingMove@ attack, Pokemon@ target, float& chance){};
    void ModifyIncomingEffectChance(ExecutingMove@ attack, Pokemon@ target, float& chance){};

    void OverrideBasePower(ExecutingMove@ attack, Pokemon@ target, uint8 hit, uint8& basePower){};
    void ChangeDamageStatsUser(ExecutingMove@ attack, Pokemon@ target, uint8 hit, Pokemon@& user){};
    void BypassDefensiveStat(ExecutingMove@ attack, Pokemon@ target, uint8 hit, bool& bypass){};
    void BypassOffensiveStat(ExecutingMove@ attack, Pokemon@ target, uint8 hit, bool& bypass){};
    void ModifyStatModifier(ExecutingMove@ attack, Pokemon@ target, uint8 hit, float& modifier){};
    void ModifyDamageModifier(ExecutingMove@ attack, Pokemon@ target, uint8 hit, float& modifier){};
    void OverrideDamage(ExecutingMove@ attack, Pokemon@ target, uint8 hit, uint& damage){};

  // PkmnLib methods
    void ModifyCriticalStage(ExecutingMove@ attack, Pokemon@ target, uint8 hit, uint8& critStage){};
    void OverrideCriticalModifier(ExecutingMove@ attack, Pokemon@ target, uint8 hit, float& critModifier){};
    void OverrideSTABModifier(ExecutingMove@ attack, Pokemon@ target, uint8 hit, float& stabModifier){};

    void ModifyExperienceGain(Pokemon@ faintedMon, Pokemon@ winningMon, uint32& critStage){};
    void DoesShareExperience(Pokemon@ faintedMon, Pokemon@ winningMon, bool& shareExperience){};
}
)");
    assert(r >= 0);
}
