#include "RegisterExecutingAttack.hpp"
#include <Arbutils/Assert.hpp>
#include <CreatureLib/Battling/Models/ExecutingAttack.hpp>
#include "../HelperFile.hpp"

void RegisterExecutingAttack::Register(asIScriptEngine* engine) {
    RegisterHitData(engine);
    RegisterExecutingAttackType(engine);
}
BORROWED_PTR_GETTER_FUNC(CreatureLib::Battling::ExecutingAttack, CreatureLib::Battling::Creature, GetUser);
BORROWED_PTR_GETTER_FUNC(CreatureLib::Battling::ExecutingAttack, CreatureLib::Battling::LearnedAttack, GetAttack);
static CreatureLib::Battling::ExecutingAttack::HitData*
GetHitDataWrapper(CreatureLib::Battling::ExecutingAttack* obj, CreatureLib::Battling::Creature* c, uint8_t hit) {
    return &obj->GetHitData(c, hit);
}

void RegisterExecutingAttack::RegisterHitData(asIScriptEngine* engine) {
    [[maybe_unused]] int r = engine->RegisterObjectType("HitData", 0, asOBJ_REF | asOBJ_NOCOUNT);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("HitData", "bool get_IsCritical() const property",
                                     asMETHOD(CreatureLib::Battling::ExecutingAttack::HitData, IsCritical),
                                     asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("HitData", "uint8 get_BasePower() const property",
                                     asMETHOD(CreatureLib::Battling::ExecutingAttack::HitData, GetBasePower),
                                     asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("HitData", "float get_Effectiveness() const property",
                                     asMETHOD(CreatureLib::Battling::ExecutingAttack::HitData, GetEffectiveness),
                                     asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("HitData", "uint get_Damage() const property",
                                     asMETHOD(CreatureLib::Battling::ExecutingAttack::HitData, GetDamage),
                                     asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("HitData", "uint8 get_Type() const property",
                                     asMETHOD(CreatureLib::Battling::ExecutingAttack::HitData, GetType),
                                     asCALL_THISCALL);
    Assert(r >= 0);
}
void RegisterExecutingAttack::RegisterExecutingAttackType(asIScriptEngine* engine) {
    [[maybe_unused]] int r = engine->RegisterObjectType("ExecutingMove", 0, asOBJ_REF | asOBJ_NOCOUNT);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("ExecutingMove", "HitData@ GetHitData(Pokemon@ target, uint8 hit) const",
                                     asFUNCTION(GetHitDataWrapper), asCALL_CDECL_OBJFIRST);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("ExecutingMove", "bool IsPokemonTarget(Pokemon@ pkmn) const",
                                     asMETHOD(CreatureLib::Battling::ExecutingAttack, IsCreatureTarget),
                                     asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("ExecutingMove", "Pokemon@ get_User() const property", asFUNCTION(GetUserWrapper),
                                     asCALL_CDECL_OBJFIRST);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("ExecutingMove", "LearnedMove@ get_Move() const property",
                                     asFUNCTION(GetAttackWrapper), asCALL_CDECL_OBJFIRST);
    Assert(r >= 0);
}
