#include "RegisterEffectParameter.hpp"
#include <Arbutils/Assert.hpp>
#include <CreatureLib/Library/EffectParameter.hpp>

static CreatureLib::Library::EffectParameter* Ref_Factory() { return new CreatureLib::Library::EffectParameter(); }

static const ArbUt::StringView& AsString(const CreatureLib::Library::EffectParameter* p) { return p->AsString(); }

void RegisterEffectParameter::Register(asIScriptEngine* engine) {
    [[maybe_unused]] int r = engine->RegisterEnum("EffectParameterType");
    Assert(r >= 0);
    for (auto val : CreatureLib::Library::EffectParameterTypeHelper::GetValues()) {
        r = engine->RegisterEnumValue("EffectParameterType",
                                      CreatureLib::Library::EffectParameterTypeHelper::ToString(val).c_str(), (int)val);
        Assert(r >= 0);
    }

    r = engine->RegisterObjectType("EffectParameter", 0, asOBJ_REF | asOBJ_NOCOUNT);
    Assert(r >= 0);

    r = engine->RegisterObjectBehaviour("EffectParameter", asBEHAVE_FACTORY, "EffectParameter@ f()",
                                        asFUNCTION(Ref_Factory), asCALL_CDECL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("EffectParameter", "EffectParameterType GetType() const",
                                     asMETHOD(CreatureLib::Library::EffectParameter, GetType), asCALL_THISCALL);
    Assert(r >= 0);

    r = engine->RegisterObjectMethod("EffectParameter", "bool AsBool() const",
                                     asMETHOD(CreatureLib::Library::EffectParameter, AsBool), asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("EffectParameter", "int64 AsInt() const",
                                     asMETHOD(CreatureLib::Library::EffectParameter, AsInt), asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod("EffectParameter", "float AsFloat() const",
                                     asMETHOD(CreatureLib::Library::EffectParameter, AsFloat), asCALL_THISCALL);
    Assert(r >= 0);
    r = engine->RegisterObjectMethod(
        "EffectParameter", "const constString& AsString() const",
        asFUNCTIONPR(AsString, (const CreatureLib::Library::EffectParameter*), const ArbUt::StringView&),
        asCALL_CDECL_OBJFIRST);
    Assert(r >= 0);
}
